*Summary Statistics of Raw Tax News Data
import delimited "data_mining/cleaned_data/tvnews_nocongressmen.csv",clear
generate date=string(v3)+string(v4,"%02.0f")
bys date: gen piecesbym=_N
bys date: gen newobs=_n==1
*correct negative data points (text typo)
replace v19=-1*v19 if v19<0
sum v19, det

bys date: egen seconds_month=sum(v19)
*revise
sort date v5
br date v5 piecesbym newobs seconds_month v19

keep if newobs==1


*number of months with any tax news
count
*number of news per month
sum piecesbym
*number of words per piece
sum tokens
*number of characters per piece
sum characters
*salience of news
tabstat seconds_month, stat(mean sd min p25 p50 p75 max count)

*Table 1
latabstat piecesbym tokens characters seconds_month, stat(mean sd min p25 p50 p75 max count) col(stat) format(%9.2f)
*Export data
export delimited date piecesbym seconds_month tokens characters using "data_mining/cleaned_data/DescTV_episode_nocongressmen2.csv", replace


************************************************
import delimited "data_mining/cleaned_data/tvnews_nocongressmen.csv",clear
generate date=string(v3)+string(v4,"%02.0f")
bys date: gen piecesbym=_N
bys date: gen newobs=_n==1
*correct negative data points (text typo)
replace v19=-1*v19 if v19<0
sum v19, det

bys date: egen seconds_month=sum(v19)

*News coverage by outlet
gen outlet = v11
gen outlet_num=.
replace outlet_num=1 if outlet=="ABC"
replace outlet_num=2 if outlet=="CBS"
replace outlet_num=3 if outlet=="NBC"
replace outlet_num=4 if outlet=="CNN"
replace outlet_num=5 if outlet=="FNC"
gen year = v3
gen month= v4
gen day = v5
gen date2=ym(year,month)
format date2 %tm


*ANNUAL
bys year: gen Tnews_year=_N
bys date outlet: gen Tchannelnews_year=_N

forvalues i=1/5{
gen channel`i'=Tchannelnews_year if outlet_num==`i'
}
forvalues i=1/5{
bys year: egen Tchannel`i'=max(channel`i')
replace Tchannel`i'=0 if Tchannel`i'==.
}

gen CTchannel1=Tchannel1
gen CTchannel2=Tchannel2+CTchannel1
gen CTchannel3=Tchannel3+CTchannel2
gen CTchannel4=Tchannel4+CTchannel3
gen CTchannel5=Tchannel5+CTchannel4

bys year: gen newobs3=_n==1
keep if newobs3==1

twoway (area CTchannel5 year, color(dknavy)) (area CTchannel4 year,color(orange)) (area CTchannel3 year,color(lavender)) (area CTchannel2 year,color(emerald)) (area CTchannel1 year,color(olive_teal)), graphregion(color(white)) legend(keygap(tiny) size(vsmall) symysize(small) symxsize(medlarge) rows(2) rowgap(minuscule) region(margin(small)) bmargin(small) on order(1 "FNC" 2 "CNN" 3 "NBC" 4 "CBS" 5 "ABC")) graphregion(color(white)) ytitle("Number of news") xtitle("Time")  xlabel(#10,labsize(small))
graph export "analysis/desc/annual_coverage.png", replace















