# Describe the rest of the data
rm(list=setdiff(ls(),"BIGSTART")) #REMOVEL ALL
library(readxl)
data <-read_excel("./analysis/tax_effects/taxshocks_rr_lags.xlsx")

# RR Exogenous Tax Liability Changes by Implementation Month
library(xts)
library(zoo)
datevar<-seq(as.Date("1945-01-01"),as.Date("2008-12-31"), by = "month")
datevar<-as.Date(datevar)
x <- zoo(data$"_tax_rr", datevar)
par(mar=c(4,4,4,4))
png('analysis/desc/implementation.png',width = 8, height = 5, units = 'in', res = 1900)
plot(x,ylab="Share of QGDP",xlab = "Time (months)",main = "")
dev.off()

# RR Episode Approvals
rm(list=setdiff(ls(),"BIGSTART")) #REMOVEL ALL

data <-read_excel("./data_mining/cleaned_data/rr_episodes.xls")

datevar<-seq(as.Date("1945-01-01"),as.Date("2008-12-31"), by = "month")
datevar<-as.Date(datevar)
x <- zoo(data$cumchange, datevar)
par(mar=c(4,4,4,4))
png('analysis/desc/approval.png',width = 8, height = 5, units = 'in', res = 1900)
plot(x,ylab="Share of QGDP",xlab = "Time (months)",main = "")
dev.off()



## Salience of tax news
rm(list=setdiff(ls(),"BIGSTART")) #REMOVEL ALL
#1) Import Data
data <-read.csv("./data_mining/cleaned_data/DescTV_episode_nocongressmen2.csv")
datevar<-seq(as.Date("1968-08-01"),as.Date("2008-12-31"), by = "month")
datevar<-as.Date(datevar)
x <- zoo(data$seconds_month, datevar)
png('analysis/desc/salience_tvnews.png',width = 8, height = 5, units = 'in', res = 1900)
plot(x,ylab="Seconds",xlab = "Time (months)",main = "")
dev.off()

