#Exploring Features for Paper 
rm(list=setdiff(ls(),"BIGSTART")) #REMOVEL ALL

#1) Import Data
data <-read.csv("./data_mining/cleaned_data/RRNews_episode_nocong2.csv")
data <-data[-1:-3,]
#2) Pre-process data
cols<-c(data$sign_t.1,data$sign_t.2,data$sign_t.3,data$seconds_t.1,data$seconds_t,data$seconds_t.1,data$seconds_t.2,data$seconds_t.3)
cols<-as.factor(cols)

library(NLP)
library(tm)
data$agnews <- as.character(data$agnews)

# Text vectorization and removal of very rare and too common. (to reduce vocab dimensionality)
mindf=ceiling(0.1*nrow(data))
maxdf=ceiling(nrow(data))

control=list(removeNumbers=FALSE, 
             removeStopwords=FALSE, 
             removePunctuation=FALSE, 
             bounds=list(global=c(mindf,maxdf)))


myCorpus <- Corpus(VectorSource(data$news_t))
tdm <- TermDocumentMatrix(myCorpus,control=control)

myCorpus <- NULL
inspect(tdm)
wordMatrix <- as.data.frame( t(as.matrix(  tdm )))
vocab<-tdm$dimnames$Terms

wmatrix<-as.matrix(tdm)
#convert to a matrix of boolean
wmatrix[wmatrix > 0]<-1
#compute term coocurrence
coocur<-wmatrix%*%t(wmatrix)
coocur<-data.frame(coocur)
rownames(coocur)<-colnames(coocur)

coocur["tax","new"]
coocur["hous","approv"]

##########################################################################################
# Descriptive Stats of News_t 
rm(list=setdiff(ls(),"BIGSTART")) #REMOVEL ALL

#1) Import Data
data <-read.csv("./data_mining/cleaned_data/RRNews_episode_nocong2.csv")
data <-data[-1:-3,]
library(NLP)
library(tm)
data$news_t <- as.character(data$news_t)

#2) Summary Statistics of News Salience
#Share of seconds in TV and tokens in Finantial columns
library(psych)
describe(data$seconds_t[5:nrow(data)])
a<-matrix(data$seconds_t[5:nrow(data)])
colSums(a!=0)


myCorpus <- Corpus(VectorSource(data$news_t))
mindf=ceiling(0.1*nrow(data))
maxdf=ceiling(nrow(data))

control=list(removeNumbers=FALSE, 
             removeStopwords=FALSE, 
             removePunctuation=FALSE, 
             bounds=list(global=c(mindf,maxdf)))

dtm <- DocumentTermMatrix(myCorpus,control=control)#use controls to show the cloud using the rf filters,control=control)
dtmc<-colSums(as.matrix(dtm))

set.seed(7)
library(wordcloud)
png('analysis/desc/wordcloud_universe_R.png',width = 5, height = 4, units = 'in', res = 800)
wordcloud(colnames(dtm),dtmc,max.words = 200, scale=c(4,0.5),random.order = FALSE)
dev.off()
#Inspect
inspect(dtm)

#compute top 20 keyword summary stats of news t vocabulary (which is to be described at Section Data)
control=list(removeNumbers=FALSE, 
             removeStopwords=FALSE, 
             removePunctuation=FALSE,bounds=list(global=c(mindf,maxdf)),wordLengths=c(0,Inf))

myCorpus <- Corpus(VectorSource(data$news_t))
tdm <- TermDocumentMatrix(myCorpus,control=control)

wordMatrix_t<-as.data.frame(t(as.matrix(tdm)))
tempi<-colSums(wordMatrix_t)

sort(tempi,decreasing = TRUE)[1:20]
#top 20 keywords
colname<-c("tax","say","presid","note","senat","report","show","cut","comment","detail","give","state","plan","repres","hous","examin","new","bill","congr","budget")
top20<-wordMatrix_t[colname]

library(psych)
describe(top20)
#not null observations
colSums(top20!=0)
