%% Figure 7
%% Comparison of unanticipated implementation effects with and without media 
% anticipations
clear
clc
load 'simuS_RRMR'
load('main_RRMR','IR')


IR0 = -1*IR.RR;
SE.RR0 = sqrt(var(RR));
LOW0 = IR0+SE.RR0';
UP0 = IR0-SE.RR0';

load 'simuS_linearMR'
load('main_linearMR','IR','prise','pcut')
lu=36+1;
la=36+1;
ja=18;
ia=3*1;

%New Media Anticipation IRs
IR1 = IR.taxmcut;
SE.Taxmcut = sqrt(var(Taxmcut));
LOW1 = IR1-SE.Taxmcut';
UP1= IR1+SE.Taxmcut';


% Unanticipated Effects  - one SE bands
timeline = [0:1:lu-1];
timeline2=[-ia:1:lu-1];
figure
plot(timeline,IR0,'b','LineWidth',1)
hold on
plot(timeline,LOW0,'b--','LineWidth',1)
hold on
plot(timeline,UP0,'b--','LineWidth',1)
hold on
plot(timeline2,IR1,'b','LineWidth',2.5)
hold on
plot(timeline2,LOW1,'b--','LineWidth',2.5)
hold on
plot(timeline2,UP1,'b--','LineWidth',2.5)
hold on
plot(timeline2, zeros(ia+lu,1), 'k--')
hold on
ylim([-1.5 3.5])
plot([0; 0], ylim','k')
hold off
grid off
axis tight
xlabel('Months') 
ylabel('Percent') 
set(gcf, 'Units', 'centimeters', 'Position', [0, 0, 18, 12])
saveas(gcf,'../../../analysis/tax_effects/results/fig7a.png')

%% Comparison anticipated tax effects with and without media anticipations
clear
clc
load 'simuS_RRMR'
load('main_RRMR','IR')

IR0 = -1*IR.MRant;
SE.MRant0 = sqrt(var(MRant));
LOW0 = IR0+SE.MRant0';
UP0 = IR0-SE.MRant0';

load 'simuS_linearMR'
load('main_linearMR','IR','prise','pcut')
lu=36+1;
la=36+1;
ja=18;
ia=3*1;


IR1 = IR.taxmcut_del;
SE.Taxmcut = sqrt(var(Taxmcut_del));
LOW1 = IR1-SE.Taxmcut';
UP1 = IR1+SE.Taxmcut';


% Anticipated Effects - one SE bands.
timeline=[-ja:1:la-1];
timeline2=[-ia-ja:1:lu-1];
figure
plot(timeline,IR0,'b','LineWidth',1)
hold on
plot(timeline,LOW0,'b--','LineWidth',1)
hold on
plot(timeline,UP0,'b--','LineWidth',1)
hold on
plot(timeline2,IR1,'b','LineWidth',2.5)
hold on
plot(timeline2,LOW1,'b--','LineWidth',2.5)
hold on
plot(timeline2,UP1,'b--','LineWidth',2.5)
hold on
plot(timeline2, zeros(ia+ja+la,1), 'k--')
hold on
ylim([-1.5 3.5])
plot([-18 0; -18 0], [ylim; ylim]', 'k')
hold on
plot([0; 0], ylim','k')
hold off
grid off
axis tight
xlabel('Months') 
ylabel('Percent') 
set(gcf, 'Units', 'centimeters', 'Position', [0, 0, 18, 12])
saveas(gcf,'../../../analysis/tax_effects/results/fig7b.png')




