function [ fun ] = ofn_taxshocks_simu( th, index, yv )
%OFN Summary of this function goes here
    % Detailed explanation goes here
    % local like,beta00,P00,it,beta10,beta11,n10,fun,Hit,mit,Rit,
    % R,F10,Q,P10,P11,W; 
   
   global tax n vfq captst pnk;           % Spesifying global variables
   
   [R,Q,H,F,G]=matrices_taxshocks(th);                  % Given th, we obtain matrices R, Q, H, F
   beta00=zeros(pnk,1);                      % Matrix (18x1)
   P00=eye(pnk);                             % Identity Matrix (18x18)
   like=zeros(captst,1);                    % Matrix (T-1x1)
   filter=zeros(captst,pnk);  % Filter inferences @
   
   %% KALMAN FILTER
   
   it=1;                                    % kalman filter iterations
   while it<=captst;                        % While iteration number is smaller than or equal to number of observations
      
      % Set row of the H matrix to zero if it is not observed
      Hit = bsxfun(@times,index(it,:)',H);  
      % In contrast, set R to zero if it is observed
      Rit = diag(bsxfun(@times,(1-index(it,:)),R));   %Rit=diagrv(zeros(ny,ny),(1-index(it,:))'.*R); 

      beta10=F*beta00+G*tax(it,:)';                      % Prediction equations now incorporate the exogenous shock
      P10=F*P00*F'+Q;                             % Prediction error is the samen because shocks are parte of the information set at t-1.  
      
      n10=yv(it,:)'-(Hit*beta10);             % Error forecast
      F10=Hit*P10*Hit'+Rit;                   % MSE of forecast remains the same as if the factor had no exogenous shocks.  
            

      like(it)=-0.5*(log(2*pi*det(F10))+(n10'/F10)*n10);    % Likelihood function
     
      K=P10*(Hit'/F10);                       % Kalman gain 
      
      beta11=beta10+K*n10;                  % Updating equations 
      filter(it,:)=beta11';
      P11=P10-K*Hit*P10;

          
      beta00=beta11;
      P00=P11;      

      it=it+1;                              %Iterating
   end
   
     fun=-(sum(like,1));                     % Sum of the likelihood
     
end

