# -*- coding: utf-8 -*-
"""
Created on Wed Jul 24 15:14:27 2019
All text in the Vanderbilt news. I use it to compute relative frequency of tax terms in a period of time. 
@author: Sandra García-Uribe
"""


import pandas as pd
import os, unicodedata
import csv,sys
import nltk, re
import numpy as np
csv.field_size_limit(1000000)    
 
#VanderBilt Television Data
os.chdir(ORPATH+'\data\Vanderbilt Dataset')
path= ORPATH+'\data\Vanderbilt Dataset'
filenames=os.listdir(path)

mention=pd.DataFrame()

for filename in filenames: 
    b=pd.read_csv(filename,header=None,encoding='utf-8',delimiter=',',quotechar='"',low_memory=False,error_bad_lines=False,quoting=1)    
    b[9]=b[9].replace(np.nan,"",regex=True)
    mention=mention.append(b,ignore_index=True)
    b=0

mention=mention.drop_duplicates()

#length of raw documents
mention['tokens']=mention[9].apply(lambda x: len(nltk.word_tokenize(x)))
mention['characters']=mention[9].apply(lambda x: len(x))


#remove any name parsing text (using the english dictionary of names from nltk)
def preprocessed(doc):
    sentences=nltk.sent_tokenize(doc)
    sentences = [nltk.word_tokenize(sent) for sent in sentences]
    sentences = [nltk.pos_tag(sent) for sent in sentences]
    return sentences
def extract_names(doc):
    names = []
    sentences = preprocessed(doc)
    for tagged_sentence in sentences:
        for chunk in nltk.ne_chunk(tagged_sentence):
            if type(chunk) == nltk.tree.Tree:
                if chunk.label() == 'PERSON':
                    names.append(' '.join([c[0] for c in chunk]))
    return names

def check2(document):
    docuni=str(unicodedata.normalize('NFKD', unicode(document)).encode('ASCII', 'ignore'))
    namestotal=extract_names(docuni)
    if len(namestotal)<100:
       regexes1=re.compile('|'.join("("+k+")" for k in namestotal))
       doclean=re.sub(regexes1,' ',docuni)
    if len(namestotal)>=100 and len(namestotal)<200:
       regexes1=re.compile('|'.join("("+k+")" for k in namestotal[0:99]))
       regexes2=re.compile('|'.join("("+k+")" for k in namestotal[99:198]))
       doclean=re.sub(regexes1,' ',docuni)
       doclean=re.sub(regexes2,' ',doclean)
    if len(namestotal)>=200 and len(namestotal)<300:
       regexes1=re.compile('|'.join("("+k+")" for k in namestotal[0:99]))
       regexes2=re.compile('|'.join("("+k+")" for k in namestotal[99:198]))
       regexes3=re.compile('|'.join("("+k+")" for k in namestotal[198:]))
       doclean=re.sub(regexes1,' ',docuni)
       doclean=re.sub(regexes2,' ',doclean)        
       doclean=re.sub(regexes3,' ',doclean)        
    return doclean

mention[9]=mention[9].apply(lambda x: check2(x))
regex2=re.compile('REPORTER:')
mention[9]=mention[9].apply(lambda x: re.sub(regex2,'',x))

#repair typos in the data where seconds get to 60, change the minute and delete seconds
mention[5][mention[5].str.contains(':60')==True]
mention[5]=mention[5].replace('05:12:60','05:13:00')
mention[5]=mention[5].replace('05:16:60','05:17:00')
mention[5]=mention[5].replace('05:41:60','05:42:00')
mention[5]=mention[5].replace('05:23:60','05:24:00')
mention[5]=mention[5].replace('05:19:60','05:20:00')
mention[5]=mention[5].replace('09:16:60','09:17:00')
mention[5]=mention[5].replace('06:52:60','06:53:00')
mention[5]=mention[5].replace('06:58:60','06:59:00')
mention[5]=mention[5].replace('06:43:60','06:44:00')
mention[5]=mention[5].replace('05:50:60','05:51:00')
mention[13]=pd.to_datetime(mention[5],errors='coerce')-pd.to_datetime(mention[4],errors='coerce')

mention[14]=mention[13].astype('timedelta64[s]')



mention=mention.drop_duplicates()

os.chdir(ORPATH+EXPATH)
mention.to_csv('allvdtv_0.csv',sep=',',encoding='utf-8')
