# -*- coding: utf-8 -*-
"""
Created on Mon Jun 06 11:10:49 2016
LOAD NEWS DATA and IDENTIFIES TAX NEWS
@author: Sandra García-Uribe
"""


import pandas as pd
import os, unicodedata
import csv,sys
import nltk, re
csv.field_size_limit(1000000)    



#VanderBilt Television Data
os.chdir(ORPATH+'\data\Vanderbilt Dataset')
path= ORPATH+'\data\Vanderbilt Dataset'
filenames=os.listdir(path) #loads all data files containing vanderbilt data.

tkeys=['tax','taxes','Tax','Taxes']
inc=['increase','increasing','increases','increased','rise','rises','rose', 'risen','increment','increments','incremented','raise']
dec=['decrease','decreasing','decreases','decreased','drop','drops','dropped','cut','cuts','reduces','reduced','reduce','cutback']


mention=pd.DataFrame()
fecha_seconds=pd.DataFrame()

for filename in filenames: 
    b=pd.read_csv(filename,header=None,encoding='utf-8',delimiter=',',quotechar='"',low_memory=False,error_bad_lines=False,quoting=1)    
    b[11]=b[9].apply(lambda x: any(_ in str(unicodedata.normalize('NFKD', unicode(x)).encode('ASCII', 'ignore')).lower() for _ in tkeys))
    istax=b.loc[(b[11]==True)] 
    mention=mention.append(istax,ignore_index=True)
    fecha_seconds=fecha_seconds.append(b[[0,1,2,4,5]].loc[(b[11]==True)]) 
    b=0
    istax=0

#remove those texts that only talk about any erratic terms, not a tax thing.
mention=mention.drop_duplicates()

mentionannex=[]
regex=re.compile('(taxi|taxidriver|taxis|taxicab|taxicabs)$')

def check1(line):
    prepro=nltk.word_tokenize(str(unicodedata.normalize('NFKD', unicode(line)).encode('ASCII', 'ignore')).lower())
    linecontains=0
    for w in prepro: 
        ishere=regex.search(w)
        if ishere!=None: linecontains=linecontains+1
    return linecontains    

mention['taxifilter']=mention[9].apply(lambda x: (check1(x))>0)    
mention=mention.loc[(mention['taxifilter']!=True)]    
mention=mention.reset_index()

mention['tokens']=mention[9].apply(lambda x: len(nltk.word_tokenize(x)))
mention['characters']=mention[9].apply(lambda x: len(x))

#remove any name parsing text (using the english dictionary of names from nltk)
def preprocessed(doc):
    sentences=nltk.sent_tokenize(doc)
    sentences = [nltk.word_tokenize(sent) for sent in sentences]
    sentences = [nltk.pos_tag(sent) for sent in sentences]
    return sentences
def extract_names(doc):
    names = []
    sentences = preprocessed(doc)
    for tagged_sentence in sentences:
        for chunk in nltk.ne_chunk(tagged_sentence):
            if type(chunk) == nltk.tree.Tree:
                if chunk.label() == 'PERSON':
                    names.append(' '.join([c[0] for c in chunk]))
    return names

def check2(document):
    docuni=str(unicodedata.normalize('NFKD', unicode(document)).encode('ASCII', 'ignore'))
    regexes=re.compile('|'.join("("+k+")" for k in extract_names(docuni)))
    doclean=re.sub(regexes,' ',docuni)
    return doclean

mention[9]=mention[9].apply(lambda x: check2(x))
regex2=re.compile('REPORTER:')
mention[9]=mention[9].apply(lambda x: re.sub(regex2,'',x))

#repair one typo in row 9473 where seconds get to 60 or over, change the minute and delete seconds
mention[5][mention[5].str.contains(':60')]
mention[12]=mention[5].replace('05:12:60','05:13:00')
mention[13]=pd.to_datetime(mention[12],errors='coerce')-pd.to_datetime(mention[4],errors='coerce')
mention[14]=mention[13].astype('timedelta64[s]')

mention=mention.drop_duplicates()

os.chdir(ORPATH+EXPATH)
mention.to_csv('tvnews_nocongressmen.csv',sep=',',encoding='utf-8')

