/*Plots*/
/*RR episodes*/
use "temp/episodedata_balanced.dta", clear
br ys ms ds id dates cumchange anticipated
drop sm dates
replace ds=1 if ds==.
gen dates=mdy(ms,ds,ys)
gen sm=mofd(dates)
format sm %tm

label variable cumchange "Percent of QGDP"
label variable sm "Date of Approval"
keep if (sm>=mdy(1,1,1947) & sm<=mdy(12,31,2008))

gen episode=0
replace episode=1 if id!=.

*To plot magnitude of tax changes as percent of gdp(at implementation) by month of approval
*1) keep only episode
bys ys ms: gen newobs=_n==1
keep if newobs==1
replace cumchange=0 if cumchange==.
replace cumchange=cumchange
export excel using "cleaned_data/rr_episodes.xls", firstrow(variables) replace


keep if id!=.
tab ms
tab ms if Episode_signed>19680631 
tabstat cumchange, stat(mean sd min p25 median p75 max count) c(v)
tabstat cumchange if Episode_signed>19680631 , stat(mean sd min p25 median p75 max count) c(v)



/*MR anticipated episodes*/
use "temp/episodedata_balanced_forimp.dta", clear
br yi mi di datei im id Episode_change_gdp idchange
keep if id!=.

rename im auxdate
sort auxdate
merge auxdate using "temp/aux_dates2.dta"

bys auxdate: egen mlc=sum(Episode_change_gdp)
bys auxdate: gen dr=_n
drop if dr>1

label variable Episode_change_gdp "Percent of GDP"
label variable auxdate "Date of Implementation"
replace Episode_change_gdp=0 if Episode_change_gdp==.
sort auxdate
cd .

*other descriptives
label variable horizon "Number of months"
label variable mi "Month of Implementation"
label variable ms "Month of Approval"

/*MR anticipation episodes*/
use "temp/episodedata_balanced_forimp.dta", clear
br yi mi di datei im id Episode_change_gdp idchange
keep if id!=.

tabstat Episode_change_gdp horizon, by(anticipated) stat(mean sd min p25 median p75 max count) c(s)
tab mi

keep if Episode_implemented>19680631
tabstat Episode_change_gdp horizon, by(anticipated) stat(mean sd min p25 median p75 max count) c(s)
tab mi
